desc 'app control'
command :app do |c|
  c.desc 'Start app task'
  c.command :start do |start|
    start.action do
        $dev.app_start
    end
  end

  c.desc 'Stop app task'
  c.command :stop do |stop|
    stop.action do
        $dev.app_stop
    end
  end

  c.desc 'Test app task presence'
  c.command :exist do |exist|
    exist.action do
        puts $dev.app_exist[0] == 1 ? 'Application exists' : "Application does not exist"
    end
  end

  c.desc 'Get app size'
  c.command [:size, :length] do |size|
    size.action do
        puts "App size = #{$dev.app_length[0]}"
    end
  end

  c.desc 'Get app state'
  c.command :state do |state|
    state.action do
        state = [
          'UNINIT',
          'LOADED',
          'RUN',
          'SLEEP',
          'INT_RUN',
          'INT_SLEEP',
          'HALTED'
        ]

        puts "App state = #{state[$dev.app_state[0]]}"
    end
  end

  c.desc 'Get app checksum'
  c.command :crc do |crc|
    crc.action do
        puts "App checksum = #{$dev.app_checksum[0].to_s(16)}"
    end
  end
end

# vim: sw=2 sts=2 ts=8:

