desc 'Device firmwares update'
command :dfu do |c|
  c.desc 'Update kernel'
  c.arg_name 'firmware.bin'
  c.command :kernel do |kernel|
    kernel.action do |global_opts, opts, args|
      exit_now! 'Invalid arguments' if args.count != 1

      filepath = args[0]

      res = $dev.nvm_load_file 1, 0, filepath

      exit_now! "Can't load firmware into buffer" if res != [0]

      res = $dev.nvm_verify_file 1, 0, filepath

      exit_now! "Can't verify firmware into buffer" if res != [0]

      addr = 0x10000

      res = $dev.firmware_program addr, Pathname.new(filepath).size()/512+1, !global_opts[:rescue]

      puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
    end
  end

  c.desc 'Update app'
  c.arg_name 'firmware.bin'
  c.command :app do |app|
    app.action do |global_opts, opts, args|
      exit_now! 'Invalid arguments' if args.count != 1

      filepath = args[0]

      res = $dev.nvm_load_file 1, 0, filepath

      exit_now! "Can't load firmware into buffer" if res != [0]

      res = $dev.nvm_verify_file 1, 0, filepath

      exit_now! "Can't verify firmware into buffer" if res != [0]

      addr = 0x20000

      res = $dev.firmware_program addr, Pathname.new(filepath).size()/512+1, !global_opts[:rescue]

      puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
    end
  end
end

# vim: sw=2 sts=2 ts=8:

