desc 'list detected devices'
command :list do |c|
  c.action do |opts|
    vid = opts[:rescue] ? 0x7580 : opts[:device].vid
    pid = opts[:rescue] ? 0x0002 : opts[:device].pid
    devs = USB.new(vid, pid).svi_devices
    
    if devs.empty?
      puts 'No devices detected'
    else
      devs.each_with_index { |dev, i|
        puts "##{i} #{dev.manufacturer} #{dev.product}"
      }
    end
  end
end
