desc 'LUN control'
command :lun do |c|
  c.desc 'Get eMMC capacity (in 512 blocks)'
  c.command :seccount do |seccount|
    seccount.action do
      capacity = $dev.lun_get_seccount[0]
      puts "eMMC capacity = #{capacity} blocks (#{capacity/2/1024/1024.0} GiB)"
    end
  end

  c.desc 'Get or set count of active LUNs'
  c.arg_name '[count]'
  c.command :count do |count|
    count.action do |global_opts, opts, args|
      if args.count == 1
        res = $dev.lun_set_count args[0].to_i

        puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
      else
        puts "Count of active LUNs = #{$dev.lun_get_count[0]}"
      end
    end
  end

  c.desc 'Set LUN mode'
  c.arg_name 'lun-number mode'
  c.command :mode do |mode|
    mode.action do |global_opts, opts, args|
      res = $dev.lun_set_mode args[0].to_i, args[1].to_i

      puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
    end
  end

  c.desc 'LUN journal commands'
  c.command :journal do |journal|
    journal.desc 'LUN journal init'
    journal.arg_name 'lun-number rec-size'
    journal.command :init do |init|
      init.action do |global_opts, opts, args|
        res = $dev.lun_format_ao args[0].to_i, args[1].to_i

        puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
      end
    end
  end

  c.desc 'LUN save table to NVM'
  c.command :save do |save|
    save.action do |global_opts, opts, args|
      res = $dev.lun_save_table

      puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
    end
  end

  c.desc 'Get or set table of LUNs'
  c.arg_name '(lun-number| start size mode flags start size ...)'
  c.command :table do |table|
    table.action do |global_opts, opts, args|
      if args.count == 1
        res = $dev.lun_get_table args[0].to_i

        if res[0] == 0
          puts res[1].inspect
        else
          puts 'Fail'.light_red
        end
      elsif args.count%4 == 0
        iargs = args.map do |elem|
          elem.to_i
        end

        res = $dev.lun_set_table iargs

        puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
      else
        puts 'Bad table description'.light_red
      end
    end
  end
end

# vim: sw=2 sts=2 ts=8:

