desc 'RTC'
command :time do |c|
  c.desc 'Synchronize time to host'
  c.command :sync do |sync|
    sync.action do |global_opts, opts, args|
      res = $dev.settime(Time.now.to_i)[0]

      puts res[0] == 0 ? 'OK'.light_green : 'Fail'.light_red
    end
  end

  c.desc 'Stop time counting'
  c.command :stop do |stop|
    stop.action do |global_opts, opts, args|
      res = $dev.stoptime[0]

      puts res[0] == 1 ? 'OK'.light_green : 'Fail'.light_red
    end
  end

  c.desc 'Start time counting'
  c.command :start do |start|
    start.action do |global_opts, opts, args|
      res = $dev.starttime[0]

      puts res[0] == 1 ? 'OK'.light_green : 'Fail'.light_red
    end
  end

  c.desc 'Is time initialized'
  c.command :state do |state|
    state.action do |global_opts, opts, args|
      res = $dev.isstartedtime

      if res[0] == 1
        puts res[1] == 1 ? 'Started'.light_green : 'Stopped'.light_yellow
      else
        puts 'Fail'.light_red
      end
    end
  end

  c.action do |global_opts, opts, args|
    res = $dev.gettime[0]

    if res < 200
      puts "Fail with code #{res}".light_red
    else
      puts "#{Time.at res}".light_yellow
    end
  end
end

# vim: sw=2 sts=2 ts=8:

